// PHPStudio.h
#pragma once

class CApplication
{
public:
	virtual int CreateView()=0;
	virtual int LoadView(LPCTSTR szFilename)=0;
	virtual BOOL SaveView(HWND hWnd,LPCTSTR szFilename)=0;
	virtual BOOL CloseView(HWND hWnd)=0;

	virtual HWND GetToolsHWND()=0;
	virtual void AddTool(HWND hWnd,LPCTSTR szTitle)=0;

	virtual LPCTSTR GetViewPath(HWND hWnd)=0;
};

class CPlugin
{
public:
	virtual ~CPlugin() {}

	virtual LPCTSTR	GetTitle() const=0;

	virtual void OnCreateView(HWND hWnd)=0;
	virtual void OnLoadView(LPCTSTR szFilename,HWND hWnd)=0;
	virtual void OnSaveView(HWND hWnd,LPCTSTR szFilename)=0;
	virtual void OnCloseView(HWND hWnd)=0;

	virtual void OnLoadProject(LPCTSTR szFilename)=0;

	virtual int GetConfigCount() const=0;
	virtual LPCPROPSHEETPAGE GetConfigPage(int nIndex) const=0;
};

typedef void(*PluginFactory)(CApplication* pApplication,CPlugin** ppPlugin);